#ifndef _XO_BOXP_H_
#define _XO_BOXP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_COMPBASEP_H_
#include <X11/Xo/CompBaseP.h>
#endif
#ifndef _XO_BOX_H_
#include <X11/Xo/Box.h>
#endif

/*
 * Box's class record.
 */
typedef struct
{
	int		filler;		/* keep compiler happy */
} XoBoxClassPart;
/*
 * Full class record for Box widget.
 */
typedef struct _XoBoxClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	XoCompBaseClassPart comp_base_class; /* the CompBase class variables */
	XoBoxClassPart	box_class;	/* the Box class variables */
} XoBoxClassRec;

extern XoBoxClassRec	xoBoxClassRec;

/*
 * Box's instance record.
 */
typedef struct
{
	Dimension	hoffset;	/* horizontal separation */
	Dimension	voffset;	/* vertical separation */
	Boolean		shrink;		/* shrink widgets if too many */
	Boolean		stretch;	/* stretch widgets if more space */
	Boolean		insert_hspace;	/* add extra space */
	Boolean		insert_vspace;	/* add extra space */
	int		num_managed;	/* number of managed children */
	Dimension	max_width;	/* widest child */
	Dimension	max_height;	/* highest child */
	int		num_cols;	/* number of columns */
} XoBoxPart;

/*
 * Box's complete instance record.
 */
typedef struct _XoBoxRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	XoCompBasePart	comp_base;	/* the CompBase instance variables */
	XoBoxPart	box;		/* the Box instance variables */
} XoBoxRec;

#endif /* _XO_BOXP_H_ */
