#ifndef _XO_BOXREC_H_
#define _XO_BOXREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoBoxWidget, box.field)
static XtResource resources[] = {
	{XtNhoffset, XtCOffset, XtRDimension, sizeof(Dimension),
	    offset(hoffset), XtRImmediate, (caddr_t) 5},
	{XtNvoffset, XtCOffset, XtRDimension, sizeof(Dimension),
	    offset(voffset), XtRImmediate, (caddr_t) 5},
	{XtNshrink, XtCShrink, XtRBoolean, sizeof(Boolean),
	    offset(shrink), XtRImmediate, (caddr_t) False},
	{XtNstretch, XtCStretch, XtRDimension, sizeof(Boolean),
	    offset(stretch), XtRImmediate, (caddr_t) True},
	{XtNinsertHspace, XtCSpacers, XtRBoolean, sizeof(Boolean),
	    offset(insert_hspace), XtRImmediate, (caddr_t) True},
	{XtNinsertVspace, XtCSpacers, XtRBoolean, sizeof(Boolean),
	    offset(insert_vspace), XtRImmediate, (caddr_t) True},
};
#undef offset
XoProto (static void,	ChangeManaged, (Widget gw));
XoProto (static XtGeometryResult,
			GeometryManager, (Widget widget, 
					  XtWidgetGeometry* request, 
					  XtWidgetGeometry* reply));
XoProto (static void,	ClassInit, (void));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static XtGeometryResult,
			QueryGeometry, (Widget widget, 
					XtWidgetGeometry* request, 
					XtWidgetGeometry* reply));
XoProto (static void,	Resize, (Widget gw));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoBoxClassRec xoBoxClassRec = {
	{ /* Core */
		(WidgetClass) &xoCompBaseClassRec, /* superclass */
		"Box",				/* class_name */
		sizeof(XoBoxRec),		/* widget_size */
		ClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		Resize,				/* Core.resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		QueryGeometry,			/* Core.query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Composite */
		GeometryManager,		/* Composite.geometry_manager */
		ChangeManaged,			/* Composite.change_managed */
		XtInheritInsertChild,		/* insert_child */
		XtInheritDeleteChild,		/* delete_child */
		_XoCompExtensionPtr,		/* Composite.extension */
	},
	{ /* CompBase */
		XtInheritTraversalProc,		/* traverse */
	},
	{ /* Box */
		0,				/* filler */
	},
};
WidgetClass xoBoxWidgetClass = (WidgetClass) &xoBoxClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoCompBaseClassRec
#define MyClass xoBoxClassRec
#define ThisSuperClass(gw) (*(XoBoxClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoBoxClassRec *)XtClass(gw))

#endif /* _XO_BOXREC_H_ */
