#ifndef _XO_BUTTONP_H_
#define _XO_BUTTONP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_LABELP_H_
#include <X11/Xo/LabelP.h>
#endif
#ifndef _XO_BUTTON_H_
#include <X11/Xo/Button.h>
#endif

/*
 * Button's class record.
 */
typedef struct
{
	XtProc		set2;		/* Called from bogus() action */
} XoButtonClassPart;
/*
 * Full class record for Button widget.
 */
typedef struct _XoButtonClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	XoSimpleClassPart simple_class;	/* the Simple class variables */
	XoLabelClassPart label_class;	/* the Label class variables */
	XoButtonClassPart button_class;	/* the Button class variables */
} XoButtonClassRec;

extern XoButtonClassRec	xoButtonClassRec;

/*
 * Button's instance record.
 */
typedef struct
{
	XtCallbackList	callbacks;	/* executed when activated */
	int		repeat_interval; /* milli. sec. between executions */
	int		repeat_delay;	/* ms delay before executions */
	int		set;		/* current state of the button */
	XtIntervalId	timer_id;	/* current timer for repeating */
	Boolean		timer_ran;	/* indicates if a timer was actived */
	Boolean		temp;		/* temporary holder for set */
} XoButtonPart;

/*
 * Button's complete instance record.
 */
typedef struct _XoButtonRec
{
	CorePart	core;		/* the Core instance variables */
	XoSimplePart	simple;		/* the Simple instance variables */
	XoLabelPart	label;		/* the Label instance variables */
	XoButtonPart	button;		/* the Button instance variables */
} XoButtonRec;

#endif /* _XO_BUTTONP_H_ */
