#ifndef _XO_BUTTONREC_H_
#define _XO_BUTTONREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS actions
#define ACTIONNUM XtNumber(actions)
XoProto (static void, Set, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Unset, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, UnsetTemp, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, SetTemp, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Notify, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Highlight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Unhighlight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, RepeatStart, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, RepeatEnd, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, KeyIgnore, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, KeyAccept, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ClipStart, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ClipEnd, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ClipStuff, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ClipGet, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemNext, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemPrev, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemUp, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemDown, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, LineEnd, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, LineBegin, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, DataBegin, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, DataEnd, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, GrabFocus, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
static XtActionsRec actions[] = {
	{"Set",	Set},
	{"Unset",	Unset},
	{"UnsetTemp",	UnsetTemp},
	{"SetTemp",	SetTemp},
	{"Notify",	Notify},
	{"Highlight",	Highlight},
	{"Unhighlight",	Unhighlight},
	{"RepeatStart",	RepeatStart},
	{"RepeatEnd",	RepeatEnd},
	{"KeyIgnore",	KeyIgnore},
	{"KeyAccept",	KeyAccept},
	{"ClipStart",	ClipStart},
	{"ClipEnd",	ClipEnd},
	{"ClipStuff",	ClipStuff},
	{"ClipGet",	ClipGet},
	{"ItemNext",	ItemNext},
	{"ItemPrev",	ItemPrev},
	{"ItemUp",	ItemUp},
	{"ItemDown",	ItemDown},
	{"LineEnd",	LineEnd},
	{"LineBegin",	LineBegin},
	{"DataBegin",	DataBegin},
	{"DataEnd",	DataEnd},
	{"GrabFocus",	GrabFocus},
};
static char translations[] = "\
	<FocusIn>:	Highlight()\n\
	<FocusOut>:	Unhighlight()\n\
	<Leave>:	UnsetTemp()\n\
	<Enter>:	SetTemp()\n\
	<Btn1Down>:	GrabFocus() Highlight() Set() RepeatStart() KeyIgnore()\n\
	<Btn1Up>:	Notify() Unset() RepeatEnd() KeyAccept()\n\
	<Key>Return:	Set() Notify() Unset()\n\
	!<Key>Tab:	ItemNext()\n\
	!Ctrl<Key>Tab:	ItemNext()\n\
	!Shift<Key>Tab:	ItemPrev()\n\
	!Shift Ctrl <Key>Tab:	ItemPrev()\n\
	!<Key>Up:	ItemUp()\n\
	!<Key>Left:	ItemUp()\n\
	!<Key>Down:	ItemDown()\n\
	!<Key>Right:	ItemDown()\n\
	!<Key>Home:	LineBegin()\n\
	!<Key>Begin:	LineBegin()\n\
	!<Key>End:	LineEnd()\n\
	!Ctrl<Key>Home:	DataBegin()\n\
	!Ctrl<Key>Begin:	DataBegin()\n\
	!Ctrl<Key>End:	DataEnd()\n\
";
#define offset(field) XtOffset(XoButtonWidget, button.field)
static XtResource resources[] = {
	{XtNborderWidth, XtCBorderWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoButtonWidget,core.border_width), XtRImmediate, 0},
	{XtNborderClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    XtOffset(XoButtonWidget,simple.border_class), XtRString, "DefaultBorder"},
	{XtNcallback, XtCCallback, XtRCallback, sizeof(XtCallbackList),
	    offset(callbacks), XtRImmediate, NULL},
	{XtNrepeatInterval, XtCRepeatInterval, XtRInt, sizeof(int),
	    offset(repeat_interval), XtRImmediate, (XtPointer) 100},
	{XtNrepeatDelay, XtCRepeatDelay, XtRInt, sizeof(int),
	    offset(repeat_delay), XtRImmediate, (XtPointer) 300},
};
#undef offset
XoProto (static void,	ClassInit, (void));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoButtonClassRec xoButtonClassRec = {
	{ /* Core */
		(WidgetClass) &xoLabelClassRec,	/* superclass */
		"Button",			/* class_name */
		sizeof(XoButtonRec),		/* widget_size */
		ClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XoFocusAccept,			/* Core.accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		translations,			/* Core.tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Simple */
		XtInheritSet,			/* set */
	},
	{ /* Label */
		XtInheritSet,			/* set2 */
	},
	{ /* Button */
		XtInheritSet,			/* set2 */
	},
};
WidgetClass xoButtonWidgetClass = (WidgetClass) &xoButtonClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoLabelClassRec
#define MyClass xoButtonClassRec
#define ThisSuperClass(gw) (*(XoButtonClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoButtonClassRec *)XtClass(gw))

#endif /* _XO_BUTTONREC_H_ */
