#ifndef _XO_COLUMNP_H_
#define _XO_COLUMNP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_CONSBASEP_H_
#include <X11/Xo/ConsBaseP.h>
#endif
#ifndef _XO_COLUMN_H_
#include <X11/Xo/Column.h>
#endif

/*
 * Column's class record.
 */
typedef struct
{
	int		filler;		/* keep compiler happy */
} XoColumnClassPart;
/*
 * Full class record for Column widget.
 */
typedef struct _XoColumnClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
	XoColumnClassPart column_class;	/* the Column class variables */
} XoColumnClassRec;

extern XoColumnClassRec	xoColumnClassRec;

/*
 * Column's instance record.
 */
typedef struct
{
	Dimension	vspace;		/* distance between widgets */
} XoColumnPart;

/*
 * Column's complete instance record.
 */
typedef struct _XoColumnRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
	XoColumnPart	column;		/* the Column instance variables */
} XoColumnRec;
/*
 * Column's partial constraint record.
 */
typedef struct
{
	int		stretch;	/* how much to expand this one */
	int		shrink;		/* how much shrink this one */
	Boolean		skip;		/* ignore this child */
	Dimension	user_height;	/* height from user */
} XoColumnConstraintPart;

/*
 * Column's complete constraint record.
 */
typedef struct _XoColumnConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
	XoColumnConstraintPart column;	/* the Column constraint variables */
} XoColumnConstraintRec, *XoColumnConstraint;

#define SKIPCHILD(c) (((XoColumnConstraint)((c)->core.constraints))->column.skip)

#endif /* _XO_COLUMNP_H_ */
