#ifndef _XO_COLUMNREC_H_
#define _XO_COLUMNREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoColumnWidget, column.field)
static XtResource resources[] = {
	{XtNvspace, XtCSpace, XtRDimension, sizeof(Dimension),
	    offset(vspace), XtRImmediate, (XtPointer) 5},
};
#undef offset
#define offset(field) XtOffset(XoColumnConstraint, column.field)
static XtResource constraintResources[] = {
	{XtNstretch, XtCStretch, XtRInt, sizeof(int),
	    offset(stretch), XtRImmediate, (XtPointer) 1},
	{XtNshrink, XtCShrink, XtRInt, sizeof(int),
	    offset(shrink), XtRImmediate, (XtPointer) 1},
};
#undef offset
XoProto (static void,	ChangeManaged, (Widget gw));
XoProto (static XtGeometryResult,
			GeometryManager, (Widget widget, 
					  XtWidgetGeometry* request, 
					  XtWidgetGeometry* reply));
XoProto (static void,	ConsInitialize, (Widget request, Widget new, 
					 ArgList arglist, Cardinal* num_args));
XoProto (extern void,	_XoClassInit, (void));
XoProto (static XtGeometryResult,
			QueryGeometry, (Widget widget, 
					XtWidgetGeometry* request, 
					XtWidgetGeometry* reply));
XoProto (static void,	Resize, (Widget gw));
XoColumnClassRec xoColumnClassRec = {
	{ /* Core */
		(WidgetClass) &xoConsBaseClassRec, /* superclass */
		"Column",			/* class_name */
		sizeof(XoColumnRec),		/* widget_size */
		_XoClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		NULL,				/* initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		Resize,				/* Core.resize */
		XtInheritExpose,		/* expose */
		NULL,				/* set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		QueryGeometry,			/* Core.query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Composite */
		GeometryManager,		/* Composite.geometry_manager */
		ChangeManaged,			/* Composite.change_managed */
		XtInheritInsertChild,		/* insert_child */
		XtInheritDeleteChild,		/* delete_child */
		_XoConsExtensionPtr,		/* Composite.extension */
	},
	{ /* Constraint */
		constraintResources,		/* resources */
		XtNumber(constraintResources),	/* num_resources */
		sizeof(XoColumnConstraintRec),	/* constraint_size */
		ConsInitialize,			/* Constraint.initialize */
		NULL,				/* destroy */
		NULL,				/* set_values */
		NULL,				/* extension */
	},
	{ /* ConsBase */
		XtInheritTraversalProc,		/* traverse */
		XtInheritSortProc,		/* sort */
	},
	{ /* Column */
		0,				/* filler */
	},
};
WidgetClass xoColumnWidgetClass = (WidgetClass) &xoColumnClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoConsBaseClassRec
#define MyClass xoColumnClassRec
#define ThisSuperClass(gw) (*(XoColumnClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoColumnClassRec *)XtClass(gw))

#endif /* _XO_COLUMNREC_H_ */
