#ifndef _XO_COMPBASEREC_H_
#define _XO_COMPBASEREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoCompBaseWidget, comp_base.field)
static XtResource resources[] = {
	{XtNborderClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(border_class), XtRString, "None"},
	{XtNborderWidget, XtCBorderWidget, XtRPointer, sizeof(Widget),
	    offset(border_widget), XtRImmediate, NULL},
	{XtNdoLayout, XtCDoLayout, XtRBoolean, sizeof(Boolean),
	    offset(do_layout), XtRImmediate, (caddr_t) True},
	{XtNtraverse, XtCTraverse, XtRCallback, sizeof(XtCallbackList),
	    offset(traverse), XtRImmediate, NULL},
	{XtNborderWidth, XtCBorderWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoCompBaseWidget,core.border_width), XtRImmediate, 0},
};
#undef offset
XoProto (static XtGeometryResult,
			GeometryManager, (Widget widget, 
					  XtWidgetGeometry* request, 
					  XtWidgetGeometry* reply));
XoProto (static void,	ClassPartInit, (WidgetClass class));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (extern void,	_XoTraverseCallback, (Widget gw, 
					      XtPointer client_data, 
					      XtPointer call_data));
XoCompBaseClassRec xoCompBaseClassRec = {
	{ /* Core */
		(WidgetClass) &compositeClassRec, /* superclass */
		"CompBase",			/* class_name */
		sizeof(XoCompBaseRec),		/* widget_size */
		NULL,				/* class_initialize */
		ClassPartInit,			/* Core.class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XoFocusAcceptComp,		/* Core.accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Composite */
		GeometryManager,		/* Composite.geometry_manager */
		XtInheritChangeManaged,		/* change_managed */
		XtInheritInsertChild,		/* insert_child */
		XtInheritDeleteChild,		/* delete_child */
		_XoCompExtensionPtr,		/* Composite.extension */
	},
	{ /* CompBase */
		_XoTraverseCallback,		/* traverse */
	},
};
WidgetClass xoCompBaseWidgetClass = (WidgetClass) &xoCompBaseClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass compositeClassRec
#define MyClass xoCompBaseClassRec
#define ThisSuperClass(gw) (*(XoCompBaseClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoCompBaseClassRec *)XtClass(gw))

#endif /* _XO_COMPBASEREC_H_ */
