#ifndef _XO_COMPBASEP_H_
#define _XO_COMPBASEP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XtCompositeP_h
#include <X11/CompositeP.h>
#endif
#ifndef _XO_COMPBASE_H_
#include <X11/Xo/CompBase.h>
#endif


#ifndef _XO_XOP_H_
#include <X11/Xo/XoP.h>
#endif

/*
 * Declare the extension record so all subclasses can have Object's
 * as children.
 */
extern CompositeClassExtensionRec _XoCompExtensionRec;
#define _XoCompExtensionPtr ((XtPointer) & _XoCompExtensionRec)


/*
 * CompBase's class record.
 */
typedef struct
{
	XtCallbackProc	traverse;	/* Handler for traverse */
} XoCompBaseClassPart;
/*
 * Full class record for CompBase widget.
 */
typedef struct _XoCompBaseClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	XoCompBaseClassPart comp_base_class; /* the CompBase class variables */
} XoCompBaseClassRec;

extern XoCompBaseClassRec	xoCompBaseClassRec;

/*
 * CompBase's instance record.
 */
typedef struct
{
	WidgetClass	border_class;	/* Widget Class of border object */
	Widget		border_widget;	/* draws the border */
	Boolean		do_layout;	/* place widgets flag */
	XtCallbackList	traverse;	/* for keyboard traversals */
} XoCompBasePart;

/*
 * CompBase's complete instance record.
 */
typedef struct _XoCompBaseRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	XoCompBasePart	comp_base;	/* the CompBase instance variables */
} XoCompBaseRec;

#define XtInheritTraversalProc ((XtCallbackProc) _XtInherit)


#endif /* _XO_COMPBASEP_H_ */
