#ifndef _XO_CONSBASEREC_H_
#define _XO_CONSBASEREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoConsBaseWidget, cons_base.field)
static XtResource resources[] = {
	{XtNborderClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(border_class), XtRString, "None"},
	{XtNborderWidget, XtCBorderWidget, XtRPointer, sizeof(Widget),
	    offset(border_widget), XtRImmediate, NULL},
	{XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel),
	    offset(fg), XtRString, XtDefaultForeground},
	{XtNdoLayout, XtCDoLayout, XtRBoolean, sizeof(Boolean),
	    offset(do_layout), XtRImmediate, (caddr_t) True},
	{XtNtraverse, XtCTraverse, XtRCallback, sizeof(XtCallbackList),
	    offset(traverse), XtRImmediate, NULL},
	{XtNborderWidth, XtCBorderWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoConsBaseWidget,core.border_width), XtRImmediate, 0},
};
#undef offset
#define offset(field) XtOffset(XoConsBaseConstraint, cons_base.field)
static XtResource constraintResources[] = {
	{XtNsortOrder, XtCSortOrder, XtRInt, sizeof(int),
	    offset(sort_order), XtRImmediate, 0},
};
#undef offset
XoProto (static void,	ChangeManaged, (Widget gw));
XoProto (static XtGeometryResult,
			GeometryManager, (Widget widget, 
					  XtWidgetGeometry* request, 
					  XtWidgetGeometry* reply));
XoProto (static void,	InsertChild, (Widget gw));
XoProto (static Boolean, ConstraintSetValues, (Widget old, Widget request, 
					       Widget new, ArgList arglist, 
					       Cardinal* num_args));
XoProto (static void,	ClassPartInit, (WidgetClass class));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static void,	SortChildren, (Widget gw));
XoProto (extern void,	_XoTraverseCallback, (Widget gw, 
					      XtPointer client_data, 
					      XtPointer call_data));
XoConsBaseClassRec xoConsBaseClassRec = {
	{ /* Core */
		(WidgetClass) &constraintClassRec, /* superclass */
		"ConsBase",			/* class_name */
		sizeof(XoConsBaseRec),		/* widget_size */
		NULL,				/* class_initialize */
		ClassPartInit,			/* Core.class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XoFocusAcceptComp,		/* Core.accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Composite */
		GeometryManager,		/* Composite.geometry_manager */
		ChangeManaged,			/* Composite.change_managed */
		InsertChild,			/* Composite.insert_child */
		XtInheritDeleteChild,		/* delete_child */
		_XoConsExtensionPtr,		/* Composite.extension */
	},
	{ /* Constraint */
		constraintResources,		/* resources */
		XtNumber(constraintResources),	/* num_resources */
		sizeof(XoConsBaseConstraintRec), /* constraint_size */
		NULL,				/* initialize */
		NULL,				/* destroy */
		ConstraintSetValues,		/* Constraint.set_values */
		NULL,				/* extension */
	},
	{ /* ConsBase */
		_XoTraverseCallback,		/* traverse */
		SortChildren,			/* sort */
	},
};
WidgetClass xoConsBaseWidgetClass = (WidgetClass) &xoConsBaseClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass constraintClassRec
#define MyClass xoConsBaseClassRec
#define ThisSuperClass(gw) (*(XoConsBaseClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoConsBaseClassRec *)XtClass(gw))

#endif /* _XO_CONSBASEREC_H_ */
