#ifndef _XO_CONSBASEP_H_
#define _XO_CONSBASEP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XtConstraintP_h
#include <X11/ConstrainP.h>
#endif
#ifndef _XO_CONSBASE_H_
#include <X11/Xo/ConsBase.h>
#endif


#ifndef _XO_XOP_H_
#include <X11/Xo/XoP.h>
#endif

/*
 * Define what the procedure for sorting the children looks like.
 */
XoProto (typedef void, (*XoSortProc), (Widget gw));

/*
 * Declare the extension record so all subclasses can have Object's
 * as children.
 */
extern CompositeClassExtensionRec _XoConsExtensionRec;
#define _XoConsExtensionPtr ((XtPointer) & _XoConsExtensionRec)


/*
 * ConsBase's class record.
 */
typedef struct
{
	XtCallbackProc	traverse;	/* Handler for traverse */
	XoSortProc	sort;		/* Sorts  children according to constr. */
} XoConsBaseClassPart;
/*
 * Full class record for ConsBase widget.
 */
typedef struct _XoConsBaseClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
} XoConsBaseClassRec;

extern XoConsBaseClassRec	xoConsBaseClassRec;

/*
 * ConsBase's instance record.
 */
typedef struct
{
	Boolean		resize_flag;	/* set if resize is called */
	WidgetClass	border_class;	/* Widget Class of border object */
	Widget		border_widget;	/* draws the border */
	Pixel		fg;		/* foreground color */
	Boolean		reorder;	/* children out of order */
	Boolean		do_layout;	/* place widgets flag */
	XtCallbackList	traverse;	/* for keyboard traversals */
} XoConsBasePart;

/*
 * ConsBase's complete instance record.
 */
typedef struct _XoConsBaseRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
} XoConsBaseRec;
/*
 * ConsBase's partial constraint record.
 */
typedef struct
{
	int		sort_order;	/* order to display children in */
} XoConsBaseConstraintPart;

/*
 * ConsBase's complete constraint record.
 */
typedef struct _XoConsBaseConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
} XoConsBaseConstraintRec, *XoConsBaseConstraint;

#define XtInheritTraversalProc ((XtCallbackProc) _XtInherit)
#define XtInheritSortProc ((XoSortProc) _XtInherit)


#endif /* _XO_CONSBASEP_H_ */
