#ifndef _XO_GRIP_H_
#define _XO_GRIP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_BUTTON_H_
#include <X11/Xo/Button.h>
#endif


/*
 * Passed as the call_data to the moveCallback.  Note that all
 * the positions are relative to the parent.  Then event contains
 * the original event.
 */

typedef struct _XoMoveCBdata
{
	XEvent		*mcbd_event;	/* original, unmodified event */
	Position	mcbd_x_first;	/* movement started, parent relative */
	Position	mcbd_y_first;
	Position	mcbd_x;		/* current position, parent relative */
	Position	mcbd_y;
} XoMoveCBdata;

/*
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
 *				 *** Core ***
 * accelerators	     Accelerators	XtTranslations	NULL
 * ancestorSensitive Sensitive		Boolean		XtCopyAncestorSensitive
 * background	     Background		Pixel		XtDefaultBackground
 * backgroundPixmap  Pixmap		Pixmap		XtUnspecifiedpixmap
 * borderColor	     BorderColor	Pixel		XtDefaultForeground
 * borderPixmap	     Pixmap		Pixmap		XtUnspecifiedPixmap
 * borderWidth	     BorderWidth	Dimension	0
 * colormap	     Colormap		Colormap	XtCopyFromParent
 * depth	     Depth		Cardinal	XtCopyFromParent
 * destroyCallback   Callback		XtCallbackList	NULL
 * height	     Height		Dimension	0
 * mappedWhenManaged MappedWhenManaged	Boolean		True
 * screen	     Screen		Screen *	XtCopyScreen
 * sensitive	     Sensitive		Boolean		True
 * translations	     Translations	XtTMRec		XtInheritTranslations
 * width	     Width		Dimension	0
 * x		     Position		Position	0
 * y		     Position		Position	0
 *				*** Simple ***
 * backingStore	     BackingStore	int		"NotUseful"
 * borderClass	     Class		WidgetClass	"None"
 * borderWidget	     BorderWidget	Widget		NULL
 * cursor	     Cursor		Cursor		"cross"
 * foreground	     Foreground		Pixel		XtDefaultForeground
 * inheritSet	     InheritSet		XtCallbackList	NULL
 * traverseAccept    TraverseAccept	Boolean		(XtPointer) True
 *				 *** Label ***
 * drawClass	     Class		WidgetClass	"ObjText"
 * drawWidget	     DrawWidget		Widget		NULL
 * flagClass	     Class		WidgetClass	NULL
 * flagJustify	     Justify		XoJustify	"Right"
 * flagWidget	     FlagWidget		Widget		NULL
 * gravity	     Gravity		XoGravity	"Center"
 * resizeDraw	     ResizeDraw		Boolean		False
 *				*** Button ***
 * callback	     Callback		XtCallbackList	NULL
 * repeatDelay	     RepeatDelay	int		(XtPointer) 300
 * repeatInterval    RepeatInterval	int		(XtPointer) 100
 *				 *** Grip ***
 * callback	     Callback		XtCallbackList	NULL
 * moveCallback	     MoveCallback	XtCallbackList	NULL
 */
extern WidgetClass		xoGripWidgetClass;

typedef struct _XoGripClassRec	*XoGripWidgetClass;
typedef struct _XoGripRec	*XoGripWidget;

#ifndef XtNmoveCallback
#	define XtNmoveCallback "moveCallback"
#endif
#ifndef XtCMoveCallback
#	define XtCMoveCallback "MoveCallback"
#endif

#endif /* _XO_GRIP_H_ */
