#ifndef _XO_GRIPP_H_
#define _XO_GRIPP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_BUTTONP_H_
#include <X11/Xo/ButtonP.h>
#endif
#ifndef _XO_GRIP_H_
#include <X11/Xo/Grip.h>
#endif

/*
 * Grip's class record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoGripClassPart;
/*
 * Full class record for Grip widget.
 */
typedef struct _XoGripClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	XoSimpleClassPart simple_class;	/* the Simple class variables */
	XoLabelClassPart label_class;	/* the Label class variables */
	XoButtonClassPart button_class;	/* the Button class variables */
	XoGripClassPart	grip_class;	/* the Grip class variables */
} XoGripClassRec;

extern XoGripClassRec	xoGripClassRec;

/*
 * Grip's instance record.
 */
typedef struct
{
	Position	x_first;	/* movement started here */
	Position	y_first;	/* movement started here */
	XtCallbackList	callbacks;	/* executed when activated */
	XtCallbackList	move_callbacks;	/* executed when activated */
} XoGripPart;

/*
 * Grip's complete instance record.
 */
typedef struct _XoGripRec
{
	CorePart	core;		/* the Core instance variables */
	XoSimplePart	simple;		/* the Simple instance variables */
	XoLabelPart	label;		/* the Label instance variables */
	XoButtonPart	button;		/* the Button instance variables */
	XoGripPart	grip;		/* the Grip instance variables */
} XoGripRec;

#endif /* _XO_GRIPP_H_ */
