#ifndef _XO_GRIPREC_H_
#define _XO_GRIPREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS actions
#define ACTIONNUM XtNumber(actions)
XoProto (static void, Set, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Unset, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Notify, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, MoveNotify, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
static XtActionsRec actions[] = {
	{"Set",	Set},
	{"Unset",	Unset},
	{"Notify",	Notify},
	{"MoveNotify",	MoveNotify},
};
static char translations[] = "\
	<Btn1Down>:	Highlight() Set()\n\
	<Btn1Motion>:	MoveNotify()\n\
	<Btn1Up>:	Notify() Unset()\n\
	<FocusIn>:	Highlight()\n\
	<FocusOut>:	Unhighlight()\n\
	<Leave>:	UnsetTemp()\n\
	<Enter>:	SetTemp()\n\
	<Key>Return:	Set() Notify() Unset()\n\
	!<Key>Tab:	ItemNext()\n\
	!Ctrl<Key>Tab:	ItemNext()\n\
	!Shift<Key>Tab:	ItemPrev()\n\
	!Shift Ctrl <Key>Tab:	ItemPrev()\n\
	!<Key>Up:	ItemUp()\n\
	!<Key>Left:	ItemUp()\n\
	!<Key>Down:	ItemDown()\n\
	!<Key>Right:	ItemDown()\n\
	!<Key>Home:	LineBegin()\n\
	!<Key>Begin:	LineBegin()\n\
	!<Key>End:	LineEnd()\n\
	!Ctrl<Key>Home:	DataBegin()\n\
	!Ctrl<Key>Begin:	DataBegin()\n\
	!Ctrl<Key>End:	DataEnd()\n\
";
#define offset(field) XtOffset(XoGripWidget, grip.field)
static XtResource resources[] = {
	{XtNborderWidth, XtCBorderWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoGripWidget,core.border_width), XtRImmediate, 0},
	{XtNwidth, XtCWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoGripWidget,core.width), XtRImmediate, (XtPointer) 10},
	{XtNheight, XtCHeight, XtRDimension, sizeof(Dimension),
	    XtOffset(XoGripWidget,core.height), XtRImmediate, (XtPointer) 10},
	{XtNborderClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    XtOffset(XoGripWidget,simple.border_class), XtRString, "DefaultBorder"},
	{XtNcallback, XtCCallback, XtRCallback, sizeof(XtCallbackList),
	    offset(callbacks), XtRImmediate, NULL},
	{XtNmoveCallback, XtCMoveCallback, XtRCallback, sizeof(XtCallbackList),
	    offset(move_callbacks), XtRImmediate, NULL},
};
#undef offset
XoProto (static void,	ClassInit, (void));
XoProto (static void,	Redisplay, (Widget gw, XEvent * event, Region region));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoGripClassRec xoGripClassRec = {
	{ /* Core */
		(WidgetClass) &xoButtonClassRec, /* superclass */
		"Grip",				/* class_name */
		sizeof(XoGripRec),		/* widget_size */
		ClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		Redisplay,			/* Core.expose */
		NULL,				/* set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XoFocusAccept,			/* Core.accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		translations,			/* Core.tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Simple */
		XtInheritSet,			/* set */
	},
	{ /* Label */
		XtInheritSet,			/* set2 */
	},
	{ /* Button */
		XtInheritSet,			/* set2 */
	},
	{ /* Grip */
		0,				/* dummy */
	},
};
WidgetClass xoGripWidgetClass = (WidgetClass) &xoGripClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoButtonClassRec
#define MyClass xoGripClassRec
#define ThisSuperClass(gw) (*(XoGripClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoGripClassRec *)XtClass(gw))

#endif /* _XO_GRIPREC_H_ */
