#ifndef _XO_LABELP_H_
#define _XO_LABELP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_SIMPLEP_H_
#include <X11/Xo/SimpleP.h>
#endif
#ifndef _XO_LABEL_H_
#include <X11/Xo/Label.h>
#endif

/*
 * Label's class record.
 */
typedef struct
{
	XtProc		set2;		/* Called from bogus() action */
} XoLabelClassPart;
/*
 * Full class record for Label widget.
 */
typedef struct _XoLabelClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	XoSimpleClassPart simple_class;	/* the Simple class variables */
	XoLabelClassPart label_class;	/* the Label class variables */
} XoLabelClassRec;

extern XoLabelClassRec	xoLabelClassRec;

/*
 * Label's instance record.
 */
typedef struct
{
	Boolean		resize_draw;	/* if resize draw widget */
	XoGravity	gravity;	/* how to place the label */
	WidgetClass	draw_class;	/* Widget class that draws */
	Widget		draw_widget;	/* Widget for drawing text. */
	WidgetClass	flag_class;	/* indicates current state */
	Widget		flag_widget;	/* Widget for current state. */
	XoJustify	flag_justify;	/* how to place the flag */
} XoLabelPart;

/*
 * Label's complete instance record.
 */
typedef struct _XoLabelRec
{
	CorePart	core;		/* the Core instance variables */
	XoSimplePart	simple;		/* the Simple instance variables */
	XoLabelPart	label;		/* the Label instance variables */
} XoLabelRec;

#endif /* _XO_LABELP_H_ */
