#ifndef _XO_LABELREC_H_
#define _XO_LABELREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoLabelWidget, label.field)
static XtResource resources[] = {
	{XtNborderWidth, XtCBorderWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoLabelWidget,core.border_width), XtRImmediate, 0},
	{XtNresizeDraw, XtCResizeDraw, XtRBoolean, sizeof(Boolean),
	    offset(resize_draw), XtRImmediate, False},
	{XtNgravity, XtCGravity, XtRGravity, sizeof(XoGravity),
	    offset(gravity), XtRString, "Center"},
	{XtNdrawClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(draw_class), XtRString, "ObjText"},
	{XtNdrawWidget, XtCDrawWidget, XtRPointer, sizeof(Widget),
	    offset(draw_widget), XtRImmediate, NULL},
	{XtNflagClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(flag_class), XtRImmediate, NULL},
	{XtNflagWidget, XtCFlagWidget, XtRPointer, sizeof(Widget),
	    offset(flag_widget), XtRImmediate, NULL},
	{XtNflagJustify, XtCJustify, XtRJustify, sizeof(XoJustify),
	    offset(flag_justify), XtRString, "Right"},
};
#undef offset
XoProto (static void,	ClassInit, (void));
XoProto (static void,	ClassPartInitialize, (WidgetClass class));
XoProto (static void,	Redisplay, (Widget gw, XEvent * event, Region region));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static XtGeometryResult,
			GeometryQuery, (Widget widget, 
					XtWidgetGeometry* request, 
					XtWidgetGeometry* reply));
XoProto (static void,	Resize, (Widget gw));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoLabelClassRec xoLabelClassRec = {
	{ /* Core */
		(WidgetClass) &xoSimpleClassRec, /* superclass */
		"Label",			/* class_name */
		sizeof(XoLabelRec),		/* widget_size */
		ClassInit,			/* Core.class_initialize */
		ClassPartInitialize,		/* Core.class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		Resize,				/* Core.resize */
		Redisplay,			/* Core.expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		GeometryQuery,			/* Core.query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Simple */
		XtInheritSet,			/* set */
	},
	{ /* Label */
		XtInheritSet,			/* set2 */
	},
};
WidgetClass xoLabelWidgetClass = (WidgetClass) &xoLabelClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoSimpleClassRec
#define MyClass xoLabelClassRec
#define ThisSuperClass(gw) (*(XoLabelClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoLabelClassRec *)XtClass(gw))

#endif /* _XO_LABELREC_H_ */
