#ifndef _XO_LISTP_H_
#define _XO_LISTP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_COLUMNP_H_
#include <X11/Xo/ColumnP.h>
#endif
#ifndef _XO_LIST_H_
#include <X11/Xo/List.h>
#endif

/*
 * List's class record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoListClassPart;
/*
 * Full class record for List widget.
 */
typedef struct _XoListClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
	XoColumnClassPart column_class;	/* the Column class variables */
	XoListClassPart	list_class;	/* the List class variables */
} XoListClassRec;

extern XoListClassRec	xoListClassRec;

/*
 * List's instance record.
 */
typedef struct
{
	XtCallbackList	callbacks;	/* executed when selected */
	Widget		current;	/* currently selected */
	int		which;		/* index of selected widget */
} XoListPart;

/*
 * List's complete instance record.
 */
typedef struct _XoListRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
	XoColumnPart	column;		/* the Column instance variables */
	XoListPart	list;		/* the List instance variables */
} XoListRec;
/*
 * List's partial constraint record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoListConstraintPart;

/*
 * List's complete constraint record.
 */
typedef struct _XoListConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
	XoColumnConstraintPart column;	/* the Column constraint variables */
	XoListConstraintPart menu;	/* the List constraint variables */
} XoListConstraintRec, *XoListConstraint;

#endif /* _XO_LISTP_H_ */
