#ifndef _XO_MENUBARBUTTONREC_H_
#define _XO_MENUBARBUTTONREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS actions
#define ACTIONNUM XtNumber(actions)
XoProto (static void, WalkMenu, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Highlight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Unhighlight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, SubmenuPopup, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, GrabFocus, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, EnableMenus, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemUp, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemDown, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, MenuRight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, MenuLeft, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, DataBegin, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, DataEnd, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, LineBegin, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, LineEnd, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
static XtActionsRec actions[] = {
	{"WalkMenu",	WalkMenu},
	{"Highlight",	Highlight},
	{"Unhighlight",	Unhighlight},
	{"SubmenuPopup",	SubmenuPopup},
	{"GrabFocus",	GrabFocus},
	{"EnableMenus",	EnableMenus},
	{"ItemUp",	ItemUp},
	{"ItemDown",	ItemDown},
	{"MenuRight",	MenuRight},
	{"MenuLeft",	MenuLeft},
	{"DataBegin",	DataBegin},
	{"DataEnd",	DataEnd},
	{"LineBegin",	LineBegin},
	{"LineEnd",	LineEnd},
};
static char translations[] = "\
	<Btn1Motion>:	WalkMenu()\n\
	<FocusIn>:	Highlight()\n\
	<FocusOut>:	Unhighlight()\n\
	<Leave>:	Unhighlight()\n\
	<Btn1Down>:	GrabFocus() EnableMenus(True) SubmenuPopup()\n\
	<Btn1Up>:	Notify() Unhighlight()\n\
	!<Key>Up:	ItemUp()\n\
	!<Key>Left:	MenuLeft()\n\
	!<Key>Down:	ItemDown()\n\
	!<Key>Right:	MenuRight()\n\
	!<Key>Home:	LineBegin()\n\
	!<Key>Begin:	LineBegin()\n\
	!<Key>End:	LineEnd()\n\
";
#define offset(field) XtOffset(XoMenuBarButtonWidget, menu_bar_button.field)
static XtResource resources[] = {
	{XtNdirection, XtCDirection, XtRPointing, sizeof(XoPointing),
	    XtOffset(XoMenuBarButtonWidget,menu_button.direction), XtRString, "Down"},
	{XtNmoveDelta, XtCDelta, XtRInt, sizeof(int),
	    XtOffset(XoMenuBarButtonWidget,menu_button.move_delta), XtRImmediate, 0},
	{XtNenablePopup, XtCEnablePopup, XtRBoolean, sizeof(Boolean),
	    offset(enable_popup), XtRImmediate, False},
};
#undef offset
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoMenuBarButtonClassRec xoMenuBarButtonClassRec = {
	{ /* Core */
		(WidgetClass) &xoMenuButtonClassRec, /* superclass */
		"MenuBarButton",		/* class_name */
		sizeof(XoMenuBarButtonRec),	/* widget_size */
		_XoClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		NULL,				/* initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		translations,			/* Core.tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Simple */
		XtInheritSet,			/* set */
	},
	{ /* Label */
		XtInheritSet,			/* set2 */
	},
	{ /* Button */
		XtInheritSet,			/* set2 */
	},
	{ /* MenuButton */
		0,				/* filler */
	},
	{ /* MenuBarButton */
		0,				/* filler */
	},
};
WidgetClass xoMenuBarButtonWidgetClass = (WidgetClass) &xoMenuBarButtonClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoMenuButtonClassRec
#define MyClass xoMenuBarButtonClassRec
#define ThisSuperClass(gw) (*(XoMenuBarButtonClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoMenuBarButtonClassRec *)XtClass(gw))

#endif /* _XO_MENUBARBUTTONREC_H_ */
