#ifndef _XO_MENUBUTTONP_H_
#define _XO_MENUBUTTONP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_BUTTONP_H_
#include <X11/Xo/ButtonP.h>
#endif
#ifndef _XO_MENUBUTTON_H_
#include <X11/Xo/MenuButton.h>
#endif

/*
 * MenuButton's class record.
 */
typedef struct
{
	int		filler;		/* keep compiler happy */
} XoMenuButtonClassPart;
/*
 * Full class record for MenuButton widget.
 */
typedef struct _XoMenuButtonClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	XoSimpleClassPart simple_class;	/* the Simple class variables */
	XoLabelClassPart label_class;	/* the Label class variables */
	XoButtonClassPart button_class;	/* the Button class variables */
	XoMenuButtonClassPart menu_button_class; /* the MenuButton class variables */
} XoMenuButtonClassRec;

extern XoMenuButtonClassRec	xoMenuButtonClassRec;

/*
 * MenuButton's instance record.
 */
typedef struct
{
	XoPointing	direction;	/* which way arrow points */
	int		move_delta;	/* delta for popups */
	Widget		submenu;	/* submenu to popup */
	Position	start_x;	/* initial x location */
	Boolean		draw_border;	/* if draw the border */
} XoMenuButtonPart;

/*
 * MenuButton's complete instance record.
 */
typedef struct _XoMenuButtonRec
{
	CorePart	core;		/* the Core instance variables */
	XoSimplePart	simple;		/* the Simple instance variables */
	XoLabelPart	label;		/* the Label instance variables */
	XoButtonPart	button;		/* the Button instance variables */
	XoMenuButtonPart menu_button;	/* the MenuButton instance variables */
} XoMenuButtonRec;

#endif /* _XO_MENUBUTTONP_H_ */
