#ifndef _XO_MENUBUTTONREC_H_
#define _XO_MENUBUTTONREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS actions
#define ACTIONNUM XtNumber(actions)
XoProto (static void, WalkMenu, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Highlight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Notify, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, Unhighlight, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemNext, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
XoProto (static void, ItemPrev, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
static XtActionsRec actions[] = {
	{"WalkMenu",	WalkMenu},
	{"Highlight",	Highlight},
	{"Notify",	Notify},
	{"Unhighlight",	Unhighlight},
	{"ItemNext",	ItemNext},
	{"ItemPrev",	ItemPrev},
};
static char translations[] = "\
	<FocusIn>:	Set() Highlight()\n\
	<FocusOut>:	Unhighlight() Unset()\n\
	<Enter>:	Highlight() Set() \n\
	<Leave>:	Unhighlight() Unset()\n\
	<Btn1Down>:	Unhighlight()\n\
	<Btn1Up>:	Notify() Unhighlight() Unset()\n\
	<Btn1Motion>:	WalkMenu()\n\
	<Key>Return:	Notify() Unhighlight() Unset()\n\
	!<Key>Up:	ItemUp()\n\
	!<Key>Down:	ItemDown()\n\
	!<Key>Left:	ItemPrev()\n\
	!<Key>Right:	ItemNext()\n\
	!<Key>Home:	LineBegin()\n\
	!<Key>Begin:	LineBegin()\n\
	!<Key>End:	LineEnd()\n\
";
#define offset(field) XtOffset(XoMenuButtonWidget, menu_button.field)
static XtResource resources[] = {
	{XtNbackingStore, XtCBackingStore, XtRBackingStore, sizeof(int),
	    XtOffset(XoMenuButtonWidget,simple.backing_store), XtRString, "Always"},
	{XtNflagClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    XtOffset(XoMenuButtonWidget,label.flag_class), XtRString, "ObjArrow"},
	{XtNdirection, XtCDirection, XtRPointing, sizeof(XoPointing),
	    offset(direction), XtRString, "Right"},
	{XtNmoveDelta, XtCDelta, XtRInt, sizeof(int),
	    offset(move_delta), XtRImmediate, (caddr_t) 5},
	{XtNsubMenu, XtCSubMenu, XtRWidget, sizeof(Widget),
	    offset(submenu), XtRImmediate, (caddr_t) NULL},
};
#undef offset
XoProto (static void,	ClassInit, (void));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoMenuButtonClassRec xoMenuButtonClassRec = {
	{ /* Core */
		(WidgetClass) &xoButtonClassRec, /* superclass */
		"MenuButton",			/* class_name */
		sizeof(XoMenuButtonRec),	/* widget_size */
		ClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		translations,			/* Core.tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Simple */
		XtInheritSet,			/* set */
	},
	{ /* Label */
		XtInheritSet,			/* set2 */
	},
	{ /* Button */
		XtInheritSet,			/* set2 */
	},
	{ /* MenuButton */
		0,				/* filler */
	},
};
WidgetClass xoMenuButtonWidgetClass = (WidgetClass) &xoMenuButtonClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoButtonClassRec
#define MyClass xoMenuButtonClassRec
#define ThisSuperClass(gw) (*(XoMenuButtonClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoMenuButtonClassRec *)XtClass(gw))

#endif /* _XO_MENUBUTTONREC_H_ */
