#ifndef _XO_MENUBARP_H_
#define _XO_MENUBARP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_ROWP_H_
#include <X11/Xo/RowP.h>
#endif
#ifndef _XO_MENUBAR_H_
#include <X11/Xo/MenuBar.h>
#endif

/*
 * MenuBar's class record.
 */
typedef struct
{
	XtCallbackProc	callback_menu;	/* for new callback */
} XoMenuBarClassPart;
/*
 * Full class record for MenuBar widget.
 */
typedef struct _XoMenuBarClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
	XoRowClassPart	row_class;	/* the Row class variables */
	XoMenuBarClassPart menu_bar_class; /* the MenuBar class variables */
} XoMenuBarClassRec;

extern XoMenuBarClassRec	xoMenuBarClassRec;

/*
 * MenuBar's instance record.
 */
typedef struct
{
	XtCallbackList	callback_menu;	/* execute for new popup */
	Widget		popup;		/* menushell to hold popups */
} XoMenuBarPart;

/*
 * MenuBar's complete instance record.
 */
typedef struct _XoMenuBarRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
	XoRowPart	row;		/* the Row instance variables */
	XoMenuBarPart	menu_bar;	/* the MenuBar instance variables */
} XoMenuBarRec;
/*
 * MenuBar's partial constraint record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoMenuBarConstraintPart;

/*
 * MenuBar's complete constraint record.
 */
typedef struct _XoMenuBarConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
	XoRowConstraintPart row;	/* the Row constraint variables */
	XoMenuBarConstraintPart menu_bar; /* the MenuBar constraint variables */
} XoMenuBarConstraintRec, *XoMenuBarConstraint;

#endif /* _XO_MENUBARP_H_ */
