#ifndef _XO_MENUBOXP_H_
#define _XO_MENUBOXP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_BOXP_H_
#include <X11/Xo/BoxP.h>
#endif
#ifndef _XO_MENUBOX_H_
#include <X11/Xo/MenuBox.h>
#endif

/*
 * MenuBox's class record.
 */
typedef struct
{
	XtCallbackProc	callback_menu;	/* for new callback */
} XoMenuBoxClassPart;
/*
 * Full class record for MenuBox widget.
 */
typedef struct _XoMenuBoxClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	XoCompBaseClassPart comp_base_class; /* the CompBase class variables */
	XoBoxClassPart	box_class;	/* the Box class variables */
	XoMenuBoxClassPart menu_box_class; /* the MenuBox class variables */
} XoMenuBoxClassRec;

extern XoMenuBoxClassRec	xoMenuBoxClassRec;

/*
 * MenuBox's instance record.
 */
typedef struct
{
	XtCallbackList	callback_menu;	/* execute for new popup */
	Widget		popup;		/* menushell to hold popups */
} XoMenuBoxPart;

/*
 * MenuBox's complete instance record.
 */
typedef struct _XoMenuBoxRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	XoCompBasePart	comp_base;	/* the CompBase instance variables */
	XoBoxPart	box;		/* the Box instance variables */
	XoMenuBoxPart	menu_box;	/* the MenuBox instance variables */
} XoMenuBoxRec;

#endif /* _XO_MENUBOXP_H_ */
