#ifndef _XO_MENUP_H_
#define _XO_MENUP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_COLUMNP_H_
#include <X11/Xo/ColumnP.h>
#endif
#ifndef _XO_MENU_H_
#include <X11/Xo/Menu.h>
#endif

/*
 * Menu's class record.
 */
typedef struct
{
	XtCallbackProc	callback_menu;	/* for new callback */
} XoMenuClassPart;
/*
 * Full class record for Menu widget.
 */
typedef struct _XoMenuClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
	XoColumnClassPart column_class;	/* the Column class variables */
	XoMenuClassPart	menu_class;	/* the Menu class variables */
} XoMenuClassRec;

extern XoMenuClassRec	xoMenuClassRec;

/*
 * Menu's instance record.
 */
typedef struct
{
	XtCallbackList	callback_menu;	/* execute for new popup */
	Widget		popup;		/* menushell to hold popups */
} XoMenuPart;

/*
 * Menu's complete instance record.
 */
typedef struct _XoMenuRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
	XoColumnPart	column;		/* the Column instance variables */
	XoMenuPart	menu;		/* the Menu instance variables */
} XoMenuRec;
/*
 * Menu's partial constraint record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoMenuConstraintPart;

/*
 * Menu's complete constraint record.
 */
typedef struct _XoMenuConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
	XoColumnConstraintPart column;	/* the Column constraint variables */
	XoMenuConstraintPart menu;	/* the Menu constraint variables */
} XoMenuConstraintRec, *XoMenuConstraint;

#endif /* _XO_MENUP_H_ */
