#ifndef _XO_MENUSHELLP_H_
#define _XO_MENUSHELLP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XtShellPrivate_h
#include <X11/ShellP.h>
#endif
#ifndef _XO_MENUSHELL_H_
#include <X11/Xo/MenuShell.h>
#endif

#ifndef _XO_XOP_H_
#include <X11/Xo/XoP.h>
#endif

static CompositeClassExtensionRec extension =
	{NULL, NULLQUARK, XtCompositeExtensionVersion,
		sizeof (CompositeClassExtensionRec), True};


/*
 * MenuShell's class record.
 */
typedef struct
{
	XtCallbackProc	callback_menu;	/* for new callback */
	XtCallbackProc	traverse;	/* Handler for traverse */
} XoMenuShellClassPart;
/*
 * Full class record for MenuShell widget.
 */
typedef struct _XoMenuShellClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ShellClassPart	shell_class;	/* the Shell class variables */
	OverrideShellClassPart override_shell_class; /* the OverrideShell class variables */
	XoMenuShellClassPart menu_shell_class; /* the MenuShell class variables */
} XoMenuShellClassRec;

extern XoMenuShellClassRec	xoMenuShellClassRec;

/*
 * MenuShell's instance record.
 */
typedef struct
{
	XtCallbackList	callback_menu;	/* execute for new popup */
	Widget		current;	/* current submenu */
	Widget		popup_starter;	/* widget that popped me up */
	Boolean		start;		/* if first in hierarchy */
	WidgetClass	border_class;	/* Widget Class of border object */
	Widget		border_widget;	/* draws the border */
	XtCallbackList	traverse;	/* for keyboard traversals */
	Boolean		resize_flag;	/* set if resize is called */
} XoMenuShellPart;

/*
 * MenuShell's complete instance record.
 */
typedef struct _XoMenuShellRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ShellPart	shell;		/* the Shell instance variables */
	OverrideShellPart override_shell; /* the OverrideShell instance variables */
	XoMenuShellPart	menu_shell;	/* the MenuShell instance variables */
} XoMenuShellRec;

#define XtInheritTraversalProc ((XtCallbackProc) _XtInherit)


#endif /* _XO_MENUSHELLP_H_ */
