#ifndef _XO_OBJ2DBORDERP_H_
#define _XO_OBJ2DBORDERP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_OBJBORDERP_H_
#include <X11/Xo/ObjBorderP.h>
#endif
#ifndef _XO_OBJ2DBORDER_H_
#include <X11/Xo/Obj2dB.h>
#endif

/*
 * Obj2dBorder's class record.
 */
typedef struct
{
	XtPointer	extension;	/* pointer to extension record */
} XoObj2dBorderClassPart;
/*
 * Full class record for Obj2dBorder widget.
 */
typedef struct _XoObj2dBorderClassRec
{
	RectObjClassPart rect_class;	/* the RectObj class variables */
	XoObjDrawClassPart obj_draw_class; /* the ObjDraw class variables */
	XoObjBorderClassPart obj_border_class; /* the ObjBorder class variables */
	XoObj2dBorderClassPart obj_2d_border_class; /* the Obj2dBorder class variables */
} XoObj2dBorderClassRec;

extern XoObj2dBorderClassRec	xoObj2dBorderClassRec;

/*
 * Obj2dBorder's instance record.
 */
typedef struct
{
	int		part_width;	/* divisor of border_width */
	GC		gc;		/* GC for drawing the border */
} XoObj2dBorderPart;

/*
 * Obj2dBorder's complete instance record.
 */
typedef struct _XoObj2dBorderRec
{
	ObjectPart	object;		/* the Object instance variables */
	RectObjPart	rectangle;	/* the RectObj instance variables */
	XoObjDrawPart	obj_draw;	/* the ObjDraw instance variables */
	XoObjBorderPart	obj_border;	/* the ObjBorder instance variables */
	XoObj2dBorderPart obj_2d_border; /* the Obj2dBorder instance variables */
} XoObj2dBorderRec;

/*
 * Return the normal border width.  Leave it as a macro in case we
 * later decide to use a floating point value for part_width.  This must
 * return an integer, 0 indicates do not draw a border.
 */
#define BORDER_WIDTH(w)	(w->obj_border.inverted?\
			w->rectangle.border_width+w->obj_2d_border.part_width:\
			w->rectangle.border_width)


#endif /* _XO_OBJ2DBORDERP_H_ */
