#ifndef _XO_OBJ3DBORDERP_H_
#define _XO_OBJ3DBORDERP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_OBJBORDERP_H_
#include <X11/Xo/ObjBorderP.h>
#endif
#ifndef _XO_OBJ3DBORDER_H_
#include <X11/Xo/Obj3dB.h>
#endif

/*
 * Obj3dBorder's class record.
 */
typedef struct
{
	XtPointer	extension;	/* pointer to extension record */
} XoObj3dBorderClassPart;
/*
 * Full class record for Obj3dBorder widget.
 */
typedef struct _XoObj3dBorderClassRec
{
	RectObjClassPart rect_class;	/* the RectObj class variables */
	XoObjDrawClassPart obj_draw_class; /* the ObjDraw class variables */
	XoObjBorderClassPart obj_border_class; /* the ObjBorder class variables */
	XoObj3dBorderClassPart obj_3d_border_class; /* the Obj3dBorder class variables */
} XoObj3dBorderClassRec;

extern XoObj3dBorderClassRec	xoObj3dBorderClassRec;

/*
 * Obj3dBorder's instance record.
 */
typedef struct
{
	Pixel		def_background;	/* background color */
	Pixel		bevel_highlight; /* Color for highlighted edge */
	Pixel		bevel_shadow;	/* Color for shadowed edge */
	GC		highlight_gc;	/* GC for upper edge */
	GC		shadow_gc;	/* GC for lower edge */
} XoObj3dBorderPart;

/*
 * Obj3dBorder's complete instance record.
 */
typedef struct _XoObj3dBorderRec
{
	ObjectPart	object;		/* the Object instance variables */
	RectObjPart	rectangle;	/* the RectObj instance variables */
	XoObjDrawPart	obj_draw;	/* the ObjDraw instance variables */
	XoObjBorderPart	obj_border;	/* the ObjBorder instance variables */
	XoObj3dBorderPart obj_3d_border; /* the Obj3dBorder instance variables */
} XoObj3dBorderRec;

#endif /* _XO_OBJ3DBORDERP_H_ */
