#ifndef _XO_OBJDRAWP_H_
#define _XO_OBJDRAWP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _Xt_RectObjP_h_
#include <X11/RectObjP.h>
#endif
#ifndef _XO_OBJDRAW_H_
#include <X11/Xo/ObjDraw.h>
#endif


#ifndef _XO_XOP_H_
#include <X11/Xo/XoP.h>
#endif

/*
 * ObjDraw's class record.
 */
typedef struct
{
	XtProc		print;		/* Called by PrintCallback */
} XoObjDrawClassPart;
/*
 * Full class record for ObjDraw widget.
 */
typedef struct _XoObjDrawClassRec
{
	RectObjClassPart rect_class;	/* the RectObj class variables */
	XoObjDrawClassPart obj_draw_class; /* the ObjDraw class variables */
} XoObjDrawClassRec;

extern XoObjDrawClassRec	xoObjDrawClassRec;

/*
 * ObjDraw's instance record.
 */
typedef struct
{
	Pixel		fg;		/* foreground color */
	XoShading	insensitive_stipple; /* insensitive stipple */
	Pixmap		stipple;	/* stipple to use */
	Boolean		no_draw;	/* should it not draw */
	XrmQuark *	inherit_resources; /* resources to inherit */
} XoObjDrawPart;

/*
 * ObjDraw's complete instance record.
 */
typedef struct _XoObjDrawRec
{
	ObjectPart	object;		/* the Object instance variables */
	RectObjPart	rectangle;	/* the RectObj instance variables */
	XoObjDrawPart	obj_draw;	/* the ObjDraw instance variables */
} XoObjDrawRec;

#endif /* _XO_OBJDRAWP_H_ */
