#ifndef _XO_OBJLABELFORMATP_H_
#define _XO_OBJLABELFORMATP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_OBJLABELP_H_
#include <X11/Xo/ObjLabelP.h>
#endif
#ifndef _XO_OBJLABELFORMAT_H_
#include <X11/Xo/ObjLabelF.h>
#endif


#include <X11/Xo/text.h>

/*
 * ObjLabelFormat's class record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoObjLabelFormatClassPart;
/*
 * Full class record for ObjLabelFormat widget.
 */
typedef struct _XoObjLabelFormatClassRec
{
	RectObjClassPart rect_class;	/* the RectObj class variables */
	XoObjDrawClassPart obj_draw_class; /* the ObjDraw class variables */
	XoObjLabelClassPart obj_label_class; /* the ObjLabel class variables */
	XoObjLabelFormatClassPart obj_label_format_class; /* the ObjLabelFormat class variables */
} XoObjLabelFormatClassRec;

extern XoObjLabelFormatClassRec	xoObjLabelFormatClassRec;

/*
 * ObjLabelFormat's instance record.
 */
typedef struct
{
	String		font_family;	/* family of fonts */
	AtFontFamily *	family;		/* the family */
	int		font_size;	/* size of the label */
	int		font_style;	/* bold, italic, etc */
	Boolean		rotate;		/* if rotate 90 degrees */
} XoObjLabelFormatPart;

/*
 * ObjLabelFormat's complete instance record.
 */
typedef struct _XoObjLabelFormatRec
{
	ObjectPart	object;		/* the Object instance variables */
	RectObjPart	rectangle;	/* the RectObj instance variables */
	XoObjDrawPart	obj_draw;	/* the ObjDraw instance variables */
	XoObjLabelPart	obj_label;	/* the ObjLabel instance variables */
	XoObjLabelFormatPart obj_label_format; /* the ObjLabelFormat instance variables */
} XoObjLabelFormatRec;

#endif /* _XO_OBJLABELFORMATP_H_ */
