#ifndef _XO_OBJLABELP_H_
#define _XO_OBJLABELP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_OBJDRAWP_H_
#include <X11/Xo/ObjDrawP.h>
#endif
#ifndef _XO_OBJLABEL_H_
#include <X11/Xo/ObjLabel.h>
#endif


typedef struct _XoLine 
{
	XtPointer	label;		/* the text to display on this line */
	Position	offset_x;	/* offset from left edge of object */
	Position	offset_y;	/* baseline of the text */
	Dimension	height;		/* height of the text (includes interline space) */
	Dimension	width;		/* width of the text */
} XoLines;

typedef struct _xo_text_info
{
	int		ti_num_lines;	/* how many lines */
	XoLines		*ti_lines;	/* list of lines; */
} _XoTextInfo;

typedef void (*XoLabelMake)(
#if NeedFunctionPrototypes
    Widget	gw,
    String	line,
    XoLines	*l
#endif
);

typedef void (*XoLabelDraw) (
#if NeedFunctionPrototypes
    Widget	gw,
    int		i,
    int		y
#endif
);

typedef void (*XoLabelFree) (
#if NeedFunctionPrototypes
    Widget	gw,
    _XoTextInfo	*tinfo,
    int		i
#endif
);

/*
 * Provide some macros to make it easier to execute the above class
 * methods.
 */
#define CallLabelMake(w,line,l) (*ThisClass ((Widget) w).obj_label_class.label_make) ((Widget) w,line,l)
#define CallLabelDraw(w,i,y) (*ThisClass ((Widget) w).obj_label_class.label_draw) ((Widget) w,i,y)
#define CallLabelFree(w,tinfo,l) (*ThisClass ((Widget) w).obj_label_class.label_free) ((Widget) w, tinfo,l)

/*
 * ObjLabel's class record.
 */
typedef struct
{
	XoLabelMake	label_make;	/* Creates the label */
	XoLabelDraw	label_draw;	/* draws the label */
	XoLabelFree	label_free;	/* deallocates the label */
} XoObjLabelClassPart;
/*
 * Full class record for ObjLabel widget.
 */
typedef struct _XoObjLabelClassRec
{
	RectObjClassPart rect_class;	/* the RectObj class variables */
	XoObjDrawClassPart obj_draw_class; /* the ObjDraw class variables */
	XoObjLabelClassPart obj_label_class; /* the ObjLabel class variables */
} XoObjLabelClassRec;

extern XoObjLabelClassRec	xoObjLabelClassRec;

/*
 * ObjLabel's instance record.
 */
typedef struct
{
	XFontStruct *	font;		/* font to draw with */
	XoJustify	justify;	/* justifcation for muli-lines */
	String		label;		/* the label string */
	GC		gc;		/* for drawing the text */
	_XoTextInfo *	lines;		/* lines of text */
	String		default_label;	/* default label */
	_XoTextInfo *	default_lines;	/* default text for size */
	Dimension	default_width;	/* normal width */
	Dimension	default_height;	/* normal height */
} XoObjLabelPart;

/*
 * ObjLabel's complete instance record.
 */
typedef struct _XoObjLabelRec
{
	ObjectPart	object;		/* the Object instance variables */
	RectObjPart	rectangle;	/* the RectObj instance variables */
	XoObjDrawPart	obj_draw;	/* the ObjDraw instance variables */
	XoObjLabelPart	obj_label;	/* the ObjLabel instance variables */
} XoObjLabelRec;

#endif /* _XO_OBJLABELP_H_ */
