#ifndef _XO_ROWP_H_
#define _XO_ROWP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_CONSBASEP_H_
#include <X11/Xo/ConsBaseP.h>
#endif
#ifndef _XO_ROW_H_
#include <X11/Xo/Row.h>
#endif

/*
 * Row's class record.
 */
typedef struct
{
	int		filler;		/* keep compiler happy */
} XoRowClassPart;
/*
 * Full class record for Row widget.
 */
typedef struct _XoRowClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
	XoRowClassPart	row_class;	/* the Row class variables */
} XoRowClassRec;

extern XoRowClassRec	xoRowClassRec;

/*
 * Row's instance record.
 */
typedef struct
{
	int		filler;		/* keep compiler happy */
} XoRowPart;

/*
 * Row's complete instance record.
 */
typedef struct _XoRowRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
	XoRowPart	row;		/* the Row instance variables */
} XoRowRec;
/*
 * Row's partial constraint record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoRowConstraintPart;

/*
 * Row's complete constraint record.
 */
typedef struct _XoRowConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
	XoRowConstraintPart row;	/* the Row constraint variables */
} XoRowConstraintRec, *XoRowConstraint;

#endif /* _XO_ROWP_H_ */
