#ifndef _XO_SCROLLBARREC_H_
#define _XO_SCROLLBARREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS actions
#define ACTIONNUM XtNumber(actions)
XoProto (static void, GripGoto, (Widget gw, XEvent *event, String *params, Cardinal *num_params));
static XtActionsRec actions[] = {
	{"GripGoto",	GripGoto},
};
static char translations[] = "\
	<Btn1Down>:	GripGoto()\n\
	<Btn1Motion>:	GripGoto()\n\
	<Btn1Up>:	GripGoto()\n\
";
#define offset(field) XtOffset(XoScrollbarWidget, scrollbar.field)
static XtResource resources[] = {
	{XtNwidth, XtCWidth, XtRDimension, sizeof(Dimension),
	    XtOffset(XoScrollbarWidget,core.width), XtRImmediate, (XtPointer) 15},
	{XtNheight, XtCHeight, XtRDimension, sizeof(Dimension),
	    XtOffset(XoScrollbarWidget,core.height), XtRImmediate, (XtPointer) 15},
	{XtNgripClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(grip_class), XtRString, "Grip"},
	{XtNgripWidget, XtCGripWidget, XtRPointer, sizeof(Widget),
	    offset(grip_widget), XtRImmediate, NULL},
	{XtNscrollerClass, XtCScrollerClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(scroller_class), XtRString, "Button"},
	{XtNscrollerDraw, XtCScrollerDraw, XtRObjectClass, sizeof(WidgetClass),
	    offset(scroller_draw), XtRString, "ObjArrow"},
	{XtNreverseScroller, XtCScroller, XtRPointer, sizeof(Widget),
	    offset(reverse_scroller), XtRImmediate, NULL},
	{XtNforwardScroller, XtCScroller, XtRPointer, sizeof(Widget),
	    offset(forward_scroller), XtRImmediate, NULL},
	{XtNincrement, XtCIncrement, XtRDouble, sizeof(double),
	    offset(increment), XtRString, ".05"},
	{XtNsize, XtCSize, XtRDouble, sizeof(double),
	    offset(size), XtRString, "0.2"},
	{XtNminGrip, XtCMinGrip, XtRDimension, sizeof(Dimension),
	    offset(min_grip), XtRImmediate, (XtPointer) 15},
	{XtNtop, XtCTop, XtRDouble, sizeof(double),
	    offset(top), XtRString, "0.0"},
	{XtNorientation, XtCOrientation, XtROrientation, sizeof(XoOrientation),
	    offset(orientation), XtRString, "Vertial"},
	{XtNcallback, XtCCallback, XtRCallback, sizeof(XtCallbackList),
	    offset(callbacks), XtRImmediate, NULL},
};
#undef offset
XoProto (static void,	ClassInit, (void));
XoProto (static void,	Destroy, (Widget gw));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static XtGeometryResult,
			GeometryQuery, (Widget widget, 
					XtWidgetGeometry* request, 
					XtWidgetGeometry* reply));
XoProto (static void,	Realize, (Widget widget, XtValueMask* mask, 
				  XSetWindowAttributes* attributes));
XoProto (static void,	Resize, (Widget gw));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoScrollbarClassRec xoScrollbarClassRec = {
	{ /* Core */
		(WidgetClass) &xoSimpleClassRec, /* superclass */
		"Scrollbar",			/* class_name */
		sizeof(XoScrollbarRec),		/* widget_size */
		ClassInit,			/* Core.class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		Realize,			/* Core.realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		Destroy,			/* Core.destroy */
		Resize,				/* Core.resize */
		XtInheritExpose,		/* expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		translations,			/* Core.tm_table */
		GeometryQuery,			/* Core.query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Simple */
		XtInheritSet,			/* set */
	},
	{ /* Scrollbar */
		0,				/* dummy */
	},
};
WidgetClass xoScrollbarWidgetClass = (WidgetClass) &xoScrollbarClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoSimpleClassRec
#define MyClass xoScrollbarClassRec
#define ThisSuperClass(gw) (*(XoScrollbarClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoScrollbarClassRec *)XtClass(gw))

#endif /* _XO_SCROLLBARREC_H_ */
