#ifndef _XO_SCROLLBAR_H_
#define _XO_SCROLLBAR_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_SIMPLE_H_
#include <X11/Xo/Simple.h>
#endif

/*
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
 *				 *** Core ***
 * accelerators	     Accelerators	XtTranslations	NULL
 * ancestorSensitive Sensitive		Boolean		XtCopyAncestorSensitive
 * background	     Background		Pixel		XtDefaultBackground
 * backgroundPixmap  Pixmap		Pixmap		XtUnspecifiedpixmap
 * borderColor	     BorderColor	Pixel		XtDefaultForeground
 * borderPixmap	     Pixmap		Pixmap		XtUnspecifiedPixmap
 * borderWidth	     BorderWidth	Dimension	0
 * colormap	     Colormap		Colormap	XtCopyFromParent
 * depth	     Depth		Cardinal	XtCopyFromParent
 * destroyCallback   Callback		XtCallbackList	NULL
 * height	     Height		Dimension	0
 * mappedWhenManaged MappedWhenManaged	Boolean		True
 * screen	     Screen		Screen *	XtCopyScreen
 * sensitive	     Sensitive		Boolean		True
 * translations	     Translations	XtTMRec		XtInheritTranslations
 * width	     Width		Dimension	0
 * x		     Position		Position	0
 * y		     Position		Position	0
 *				*** Simple ***
 * backingStore	     BackingStore	int		"NotUseful"
 * borderClass	     Class		WidgetClass	"None"
 * borderWidget	     BorderWidget	Widget		NULL
 * cursor	     Cursor		Cursor		"cross"
 * foreground	     Foreground		Pixel		XtDefaultForeground
 * inheritSet	     InheritSet		XtCallbackList	NULL
 * traverseAccept    TraverseAccept	Boolean		(XtPointer) True
 *			       *** Scrollbar ***
 * callback	     Callback		XtCallbackList	NULL
 * forwardScroller   Scroller		Widget		NULL
 * gripClass	     Class		WidgetClass	"Grip"
 * gripWidget	     GripWidget		Widget		NULL
 * increment	     Increment		double		".05"
 * minGrip	     MinGrip		Dimension	(XtPointer) 15
 * orientation	     Orientation	XoOrientation	"Vertial"
 * reverseScroller   Scroller		Widget		NULL
 * scrollerClass     ScrollerClass	WidgetClass	"Button"
 * scrollerDraw	     ScrollerDraw	WidgetClass	"ObjArrow"
 * size		     Size		double		"0.2"
 * top		     Top		double		"0.0"
 */
extern WidgetClass		xoScrollbarWidgetClass;

typedef struct _XoScrollbarClassRec *XoScrollbarWidgetClass;
typedef struct _XoScrollbarRec	*XoScrollbarWidget;

#ifndef XtNcallback
#	define XtNcallback "callback"
#endif
#ifndef XtNforwardScroller
#	define XtNforwardScroller "forwardScroller"
#endif
#ifndef XtNgripClass
#	define XtNgripClass "gripClass"
#endif
#ifndef XtNgripWidget
#	define XtNgripWidget "gripWidget"
#endif
#ifndef XtNincrement
#	define XtNincrement "increment"
#endif
#ifndef XtNminGrip
#	define XtNminGrip "minGrip"
#endif
#ifndef XtNorientation
#	define XtNorientation "orientation"
#endif
#ifndef XtNreverseScroller
#	define XtNreverseScroller "reverseScroller"
#endif
#ifndef XtNscrollerClass
#	define XtNscrollerClass "scrollerClass"
#endif
#ifndef XtNscrollerDraw
#	define XtNscrollerDraw "scrollerDraw"
#endif
#ifndef XtNsize
#	define XtNsize "size"
#endif
#ifndef XtNtop
#	define XtNtop "top"
#endif
#ifndef XtCScroller
#	define XtCScroller "Scroller"
#endif
#ifndef XtCGripWidget
#	define XtCGripWidget "GripWidget"
#endif
#ifndef XtCIncrement
#	define XtCIncrement "Increment"
#endif
#ifndef XtCMinGrip
#	define XtCMinGrip "MinGrip"
#endif
#ifndef XtCOrientation
#	define XtCOrientation "Orientation"
#endif
#ifndef XtCScrollerClass
#	define XtCScrollerClass "ScrollerClass"
#endif
#ifndef XtCScrollerDraw
#	define XtCScrollerDraw "ScrollerDraw"
#endif
#ifndef XtCSize
#	define XtCSize "Size"
#endif
#ifndef XtCTop
#	define XtCTop "Top"
#endif
#ifndef XtRDouble
#	define XtRDouble "Double"
#endif
#ifndef XtROrientation
#	define XtROrientation "Orientation"
#endif

#endif /* _XO_SCROLLBAR_H_ */
