#ifndef _XO_SCROLLBARP_H_
#define _XO_SCROLLBARP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_SIMPLEP_H_
#include <X11/Xo/SimpleP.h>
#endif
#ifndef _XO_SCROLLBAR_H_
#include <X11/Xo/Scrollbar.h>
#endif

/*
 * Scrollbar's class record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoScrollbarClassPart;
/*
 * Full class record for Scrollbar widget.
 */
typedef struct _XoScrollbarClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	XoSimpleClassPart simple_class;	/* the Simple class variables */
	XoScrollbarClassPart scrollbar_class; /* the Scrollbar class variables */
} XoScrollbarClassRec;

extern XoScrollbarClassRec	xoScrollbarClassRec;

/*
 * Scrollbar's instance record.
 */
typedef struct
{
	Boolean		direction;	/* True if forward. */
	WidgetClass	grip_class;	/* widget class of Grip */
	Dimension	orig_width;	/* preferred width */
	Dimension	orig_height;	/* preferred height */
	Widget		grip_widget;	/* draws the grip */
	WidgetClass	scroller_class;	/* class for scrollers */
	WidgetClass	scroller_draw;	/* what scroller displays */
	Widget		reverse_scroller; /* causes reverse scrolling */
	Widget		forward_scroller; /* causes forward scrolling */
	double		increment;	/* amount to move grip */
	double		size;		/* size of Grip, as percent */
	Dimension	min_grip;	/* minimum size of Grip */
	double		top;		/* location of Grip's top */
	XoOrientation	orientation;	/* vertical or horizontal */
	XtCallbackList	callbacks;	/* executed on grip movement */
} XoScrollbarPart;

/*
 * Scrollbar's complete instance record.
 */
typedef struct _XoScrollbarRec
{
	CorePart	core;		/* the Core instance variables */
	XoSimplePart	simple;		/* the Simple instance variables */
	XoScrollbarPart	scrollbar;	/* the Scrollbar instance variables */
} XoScrollbarRec;

#endif /* _XO_SCROLLBARP_H_ */
