#ifndef _XO_SIMPLEP_H_
#define _XO_SIMPLEP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef XtCoreP_h
#include <X11/CoreP.h>
#endif
#ifndef _XO_SIMPLE_H_
#include <X11/Xo/Simple.h>
#endif

#ifndef _XO_XOP_H_
#include <X11/Xo/XoP.h>
#endif

/*
 * Simple's class record.
 */
typedef struct
{
	XtProc		set;		/* Called from Set() action */
} XoSimpleClassPart;
/*
 * Full class record for Simple widget.
 */
typedef struct _XoSimpleClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	XoSimpleClassPart simple_class;	/* the Simple class variables */
} XoSimpleClassRec;

extern XoSimpleClassRec	xoSimpleClassRec;

/*
 * Simple's instance record.
 */
typedef struct
{
	WidgetClass	border_class;	/* Widget Class of border object */
	Widget		border_widget;	/* draws the border */
	Pixel		fg;		/* foreground color */
	Cursor		cursor;		/* cursor pattern */
	int		backing_store;	/* backing store */
	XtCallbackList	inherit_set;	/* to set inherited values */
	Boolean		traverse_accept; /* if accept focus */
} XoSimplePart;

/*
 * Simple's complete instance record.
 */
typedef struct _XoSimpleRec
{
	CorePart	core;		/* the Core instance variables */
	XoSimplePart	simple;		/* the Simple instance variables */
} XoSimpleRec;
#define XtInheritSet NULL

#endif /* _XO_SIMPLEP_H_ */
