#ifndef _XO_VIEWPORTREC_H_
#define _XO_VIEWPORTREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoViewportWidget, viewport.field)
static XtResource resources[] = {
	{XtNscrollbarVertAlways, XtCScrollbarAlways, XtRBoolean, sizeof(Boolean),
	    offset(scrollbar_vert_always), XtRImmediate, False},
	{XtNscrollbarHorAlways, XtCScrollbarAlways, XtRBoolean, sizeof(Boolean),
	    offset(scrollbar_hor_always), XtRImmediate, False},
	{XtNchildFill, XtCChildFill, XtRBoolean, sizeof(Boolean),
	    offset(child_fill), XtRImmediate, (XtPointer) True},
	{XtNscrollbarClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(scrollbar_class), XtRString, "Scrollbar"},
	{XtNscrollbarVertical, XtCScrollbar, XtRPointer, sizeof(Widget),
	    offset(scrollbar_vertical), XtRImmediate, NULL},
	{XtNscrollbarHorizontal, XtCScrollbar, XtRPointer, sizeof(Widget),
	    offset(scrollbar_horizontal), XtRImmediate, NULL},
};
#undef offset
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoViewportClassRec xoViewportClassRec = {
	{ /* Core */
		(WidgetClass) &xoCompBaseClassRec, /* superclass */
		"Viewport",			/* class_name */
		sizeof(XoViewportRec),		/* widget_size */
		NULL,				/* class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		XtInheritRealize,		/* realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		NULL,				/* destroy */
		XtInheritResize,		/* resize */
		XtInheritExpose,		/* expose */
		NULL,				/* set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Composite */
		XtInheritGeometryManager,	/* geometry_manager */
		XtInheritChangeManaged,		/* change_managed */
		XtInheritInsertChild,		/* insert_child */
		XtInheritDeleteChild,		/* delete_child */
		_XoCompExtensionPtr,		/* Composite.extension */
	},
	{ /* CompBase */
		XtInheritTraversalProc,		/* traverse */
	},
	{ /* Viewport */
		0,				/* dummy */
	},
};
WidgetClass xoViewportWidgetClass = (WidgetClass) &xoViewportClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoCompBaseClassRec
#define MyClass xoViewportClassRec
#define ThisSuperClass(gw) (*(XoViewportClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoViewportClassRec *)XtClass(gw))

#endif /* _XO_VIEWPORTREC_H_ */
