#ifndef _XO_VIEWPORT_H_
#define _XO_VIEWPORT_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_COMPBASE_H_
#include <X11/Xo/CompBase.h>
#endif

/*
 * Name		     Class		RepType		Default Value
 * ----		     -----		-------		-------------
 *				 *** Core ***
 * accelerators	     Accelerators	XtTranslations	NULL
 * ancestorSensitive Sensitive		Boolean		XtCopyAncestorSensitive
 * background	     Background		Pixel		XtDefaultBackground
 * backgroundPixmap  Pixmap		Pixmap		XtUnspecifiedpixmap
 * borderColor	     BorderColor	Pixel		XtDefaultForeground
 * borderPixmap	     Pixmap		Pixmap		XtUnspecifiedPixmap
 * borderWidth	     BorderWidth	Dimension	0
 * colormap	     Colormap		Colormap	XtCopyFromParent
 * depth	     Depth		Cardinal	XtCopyFromParent
 * destroyCallback   Callback		XtCallbackList	NULL
 * height	     Height		Dimension	0
 * mappedWhenManaged MappedWhenManaged	Boolean		True
 * screen	     Screen		Screen *	XtCopyScreen
 * sensitive	     Sensitive		Boolean		True
 * translations	     Translations	XtTMRec		XtInheritTranslations
 * width	     Width		Dimension	0
 * x		     Position		Position	0
 * y		     Position		Position	0
 *			       *** Composite ***
 * children	     ReadOnly		WidgetList	NULL
 * insertPosition    InsertPosition	XtOrderProc	NULL
 * numChildren	     ReadOnly		Cardinal	NULL
 *			       *** CompBase ***
 * borderClass	     Class		WidgetClass	"None"
 * borderWidget	     BorderWidget	Widget		NULL
 * doLayout	     DoLayout		Boolean		(caddr_t) True
 * traverse	     Traverse		XtCallbackList	NULL
 *			       *** Viewport ***
 * childFill	     ChildFill		Boolean		(XtPointer) True
 * scrollbarClass    Class		WidgetClass	"Scrollbar"
 * scrollbarHorAlways ScrollbarAlways	Boolean		False
 * scrollbarHorizontal Scrollbar	Widget		NULL
 * scrollbarVertAlways ScrollbarAlways	Boolean		False
 * scrollbarVertical Scrollbar		Widget		NULL
 */
extern WidgetClass		xoViewportWidgetClass;

typedef struct _XoViewportClassRec *XoViewportWidgetClass;
typedef struct _XoViewportRec	*XoViewportWidget;

#ifndef XtNchildFill
#	define XtNchildFill "childFill"
#endif
#ifndef XtNscrollbarClass
#	define XtNscrollbarClass "scrollbarClass"
#endif
#ifndef XtNscrollbarHorAlways
#	define XtNscrollbarHorAlways "scrollbarHorAlways"
#endif
#ifndef XtNscrollbarHorizontal
#	define XtNscrollbarHorizontal "scrollbarHorizontal"
#endif
#ifndef XtNscrollbarVertAlways
#	define XtNscrollbarVertAlways "scrollbarVertAlways"
#endif
#ifndef XtNscrollbarVertical
#	define XtNscrollbarVertical "scrollbarVertical"
#endif
#ifndef XtCChildFill
#	define XtCChildFill "ChildFill"
#endif
#ifndef XtCScrollbarAlways
#	define XtCScrollbarAlways "ScrollbarAlways"
#endif
#ifndef XtCScrollbar
#	define XtCScrollbar "Scrollbar"
#endif

#endif /* _XO_VIEWPORT_H_ */
