#ifndef _XO_VIEWPORTP_H_
#define _XO_VIEWPORTP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_COMPBASEP_H_
#include <X11/Xo/CompBaseP.h>
#endif
#ifndef _XO_VIEWPORT_H_
#include <X11/Xo/Viewport.h>
#endif

/*
 * Viewport's class record.
 */
typedef struct
{
	int		dummy;		/* keep compiler happy */
} XoViewportClassPart;
/*
 * Full class record for Viewport widget.
 */
typedef struct _XoViewportClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	XoCompBaseClassPart comp_base_class; /* the CompBase class variables */
	XoViewportClassPart viewport_class; /* the Viewport class variables */
} XoViewportClassRec;

extern XoViewportClassRec	xoViewportClassRec;

/*
 * Viewport's instance record.
 */
typedef struct
{
	Boolean		scrollbar_vert_always; /* display scrollbar_v? */
	Boolean		scrollbar_hor_always; /* display scrollbar_h? */
	Boolean		child_fill;	/* force small child to fill clip */
	Window		clip;		/* child is clipped to this size */
	WidgetClass	scrollbar_class; /* widget class for scrollbars. */
	Widget		scrollbar_vertical; /* vertical scrollbar */
	Widget		scrollbar_horizontal; /* horizontal scrollbar */
} XoViewportPart;

/*
 * Viewport's complete instance record.
 */
typedef struct _XoViewportRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	XoCompBasePart	comp_base;	/* the CompBase instance variables */
	XoViewportPart	viewport;	/* the Viewport instance variables */
} XoViewportRec;

#endif /* _XO_VIEWPORTP_H_ */
