#ifndef _XO_VPANEP_H_
#define _XO_VPANEP_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#ifndef _XO_COLUMNP_H_
#include <X11/Xo/ColumnP.h>
#endif
#ifndef _XO_VPANE_H_
#include <X11/Xo/Vpane.h>
#endif


typedef enum {XoCHILD, XoGRIP} XoChildType;
#define VPCONS(w) (XoVpaneConstraint) ((w)->core.constraints)

/*
 * Vpane's class record.
 */
typedef struct
{
	int		filler;		/* compiler joy */
} XoVpaneClassPart;
/*
 * Full class record for Vpane widget.
 */
typedef struct _XoVpaneClassRec
{
	CoreClassPart	core_class;	/* the Core class variables */
	CompositeClassPart composite_class; /* the Composite class variables */
	ConstraintClassPart constraint_class; /* the Constraint class variables */
	XoConsBaseClassPart cons_base_class; /* the ConsBase class variables */
	XoColumnClassPart column_class;	/* the Column class variables */
	XoVpaneClassPart vpane_class;	/* the Vpane class variables */
} XoVpaneClassRec;

extern XoVpaneClassRec	xoVpaneClassRec;

/*
 * Vpane's instance record.
 */
typedef struct
{
	GC		gc;		/* for drawing lines */
	GC		move_gc;	/* for drawing lines */
	int		total_stretch;	/* summary of stretch */
	int		total_shrink;	/* summary of shrink */
	Position	start_y;	/* starting position */
	Widget		moving_grip;	/* grip currentl moving */
	WidgetClass	grip_class;	/* what widget to create */
	int		grip_count;	/* number of grips */
	Widget *	grips;		/* list of grips */
	int		layout_grips;	/* safe to place grips */
} XoVpanePart;

/*
 * Vpane's complete instance record.
 */
typedef struct _XoVpaneRec
{
	CorePart	core;		/* the Core instance variables */
	CompositePart	composite;	/* the Composite instance variables */
	ConstraintPart	constraint;	/* the Constraint instance variables */
	XoConsBasePart	cons_base;	/* the ConsBase instance variables */
	XoColumnPart	column;		/* the Column instance variables */
	XoVpanePart	vpane;		/* the Vpane instance variables */
} XoVpaneRec;
/*
 * Vpane's partial constraint record.
 */
typedef struct
{
	XoChildType	type;		/* is this Grip or other */
	Widget		before;		/* matching child to grip */
	Widget		after;		/* matching child to grip */
	Position	orig_y;		/* normal y position */
} XoVpaneConstraintPart;

/*
 * Vpane's complete constraint record.
 */
typedef struct _XoVpaneConstraintRec
{
	XoConsBaseConstraintPart cons_base; /* the ConsBase constraint variables */
	XoColumnConstraintPart column;	/* the Column constraint variables */
	XoVpaneConstraintPart vpane;	/* the Vpane constraint variables */
} XoVpaneConstraintRec, *XoVpaneConstraint;

#endif /* _XO_VPANEP_H_ */
