#ifndef _XO_VPANEREC_H_
#define _XO_VPANEREC_H_
/*
 * $Id:$
 *
 * $Log:$
 */
#define ACTIONS NULL
#define ACTIONNUM 0
#define offset(field) XtOffset(XoVpaneWidget, vpane.field)
static XtResource resources[] = {
	{XtNvspace, XtCSpace, XtRDimension, sizeof(Dimension),
	    XtOffset(XoVpaneWidget,column.vspace), XtRImmediate, (XtPointer) 10},
	{XtNgripClass, XtCClass, XtRObjectClass, sizeof(WidgetClass),
	    offset(grip_class), XtRString, "Grip"},
};
#undef offset
#define offset(field) XtOffset(XoVpaneConstraint, vpane.field)
static XtResource constraintResources[] = {
	{XtNchildType, XtCChildType, XtRChildType, sizeof(XoChildType),
	    offset(type), XtRImmediate, XoCHILD},
};
#undef offset
XoProto (static void,	ChangeManaged, (Widget gw));
XoProto (static void,	InsertChild, (Widget gw));
XoProto (static void,	ConsInitialize, (Widget request, Widget new, 
					 ArgList arglist, Cardinal* num_args));
XoProto (static void,	Destroy, (Widget gw));
XoProto (static void,	Redisplay, (Widget gw, XEvent * event, Region region));
XoProto (static void,	Initialize, (Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoProto (static void,	Realize, (Widget widget, XtValueMask* mask, 
				  XSetWindowAttributes* attributes));
XoProto (static void,	Resize, (Widget gw));
XoProto (static Boolean, SetValues, (Widget old, Widget request, Widget new, 
				     ArgList arglist, Cardinal* num_args));
XoVpaneClassRec xoVpaneClassRec = {
	{ /* Core */
		(WidgetClass) &xoColumnClassRec, /* superclass */
		"Vpane",			/* class_name */
		sizeof(XoVpaneRec),		/* widget_size */
		NULL,				/* class_initialize */
		NULL,				/* class_part_initialize */
		False,				/* class_inited */
		Initialize,			/* Core.initialize */
		NULL,				/* initialize_hook */
		Realize,			/* Core.realize */
		ACTIONS,			/* actions */
		ACTIONNUM,			/* num_actions */
		resources,			/* resources */
		XtNumber(resources),		/* num_resources */
		NULLQUARK,			/* xrm_class */
		True,				/* compress_motion */
		True,				/* compress_exposure */
		True,				/* compress_enterleave */
		False,				/* visible_interest */
		Destroy,			/* Core.destroy */
		Resize,				/* Core.resize */
		Redisplay,			/* Core.expose */
		SetValues,			/* Core.set_values */
		NULL,				/* set_values_hook */
		XtInheritSetValuesAlmost,	/* set_values_almost */
		NULL,				/* get_values_hook */
		XtInheritAcceptFocus,		/* accept_focus */
		XtVersion,			/* version */
		NULL,				/* callback_private */
		NULL,				/* tm_table */
		XtInheritQueryGeometry,		/* query_geometry */
		NULL,				/* display_accelerator */
		NULL,				/* extension */
	},
	{ /* Composite */
		XtInheritGeometryManager,	/* geometry_manager */
		ChangeManaged,			/* Composite.change_managed */
		InsertChild,			/* Composite.insert_child */
		XtInheritDeleteChild,		/* delete_child */
		_XoConsExtensionPtr,		/* Composite.extension */
	},
	{ /* Constraint */
		constraintResources,		/* resources */
		XtNumber(constraintResources),	/* num_resources */
		sizeof(XoVpaneConstraintRec),	/* constraint_size */
		ConsInitialize,			/* Constraint.initialize */
		NULL,				/* destroy */
		NULL,				/* set_values */
		NULL,				/* extension */
	},
	{ /* ConsBase */
		XtInheritTraversalProc,		/* traverse */
		XtInheritSortProc,		/* sort */
	},
	{ /* Column */
		0,				/* filler */
	},
	{ /* Vpane */
		0,				/* filler */
	},
};
WidgetClass xoVpaneWidgetClass = (WidgetClass) &xoVpaneClassRec;

/*
 * The following make it easier to access class methods.
 */
#define MySuperClass xoColumnClassRec
#define MyClass xoVpaneClassRec
#define ThisSuperClass(gw) (*(XoVpaneClassRec *)XtSuperClass(gw))
#define ThisClass(gw) (*(XoVpaneClassRec *)XtClass(gw))

#endif /* _XO_VPANEREC_H_ */
