/*
 * ObjDraw.c,v 2.1 1992/08/11 00:17:20 pete Exp
 * ObjDraw.c,v
 * Revision 2.1  1992/08/11  00:17:20  pete
 * Added stdio.h.
 *
 * Revision 2.0  1992/04/23  02:51:45  ware
 * First public release.
 *
 * Revision 1.9  1992/02/27  14:30:29  ware
 * Compiled with GCC 2.0 and very strict checks.  Fixed Warnings
 *
 * Revision 1.8  1992/02/20  15:11:09  ware
 * Applied new indentation
 *
 * Revision 1.7  1992/02/04  21:22:46  pete
 * Release 44
 *
 * Revision 1.6  1991/08/26  11:58:02  pete
 * Use XoProto() for conditional prototypes.  Working on getting traversals
 * and menus to work more efficiently.  Changed to following naming
 * conventions.
 *
 * Revision 1.5  91/07/19  00:59:55  pete
 * Use shorter file names.  Various speedups.
 *
 * Revision 1.4  91/06/01  10:03:19  pete
 * Working on menubar
 *
 * Revision 1.3  91/05/22  17:49:43  pete
 * Get it to compile cleanely.  Menus almost work.
 *
 * Revision 1.2  91/05/17  10:09:21  pete
 * Should be passing a pointer to a region in _xoObjRedisplay().
 *
 * Revision 1.1  91/05/15  08:56:45  pete
 * Initial revision
 *
 */

#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/Xo/ObjDrawP.h>

#include <X11/Xo/ObjDrawRec.h>

static void
Initialize (request, new, arglist, num_args)
	Widget          request;	/* as first created */
	Widget          new;		/* after other parent classes */
	ArgList         arglist;	/* args passed to create */
	Cardinal       *num_args;	/* number of arguments */
{

	_XoInheritedGet (XtParent (new), new);
}

static Boolean
SetValues (current, request, new, args, num_args)
	Widget          current;	/* widget before the XtSetValues() */
	Widget          request;	/* after args applied but no
					 * set_values */
	Widget          new;		/* the allowed changes */
	ArgList         args;		/* list of arguments */
	Cardinal       *num_args;	/* how many arguments */
{
	XoObjDrawWidget w = (XoObjDrawWidget) new;
	XoObjDrawWidget cur = (XoObjDrawWidget) current;
	Boolean         redisplay = False;

	if (w->obj_draw.no_draw != cur->obj_draw.no_draw)
		redisplay = w->obj_draw.no_draw;
	return redisplay;
}
